<%@page contentType="text/html; charset=utf-8" %> 
<%@page
	import="com.sas.analytics.mfg.warranty.webapp.lpage.config.ConfigConstants"%>
<%@page
	import="com.sas.analytics.mfg.warranty.webapp.lpage.util.WebUtil"%>
<%@page import="java.util.List"%>
<%@page import="java.util.Iterator"%>
<%@page import="java.util.Locale"%>
<%@page
	import="com.sas.analytics.mfg.warranty.webapp.lpage.ei.model.EICategoryResults"%>
<%@page	import="com.sas.analytics.mfg.warranty.coreapi.ei.client.EIType"%>
<%@page	import="com.sas.analytics.mfg.warranty.coreapi.ei.client.EIAlertFilter"%>
<%@page errorPage="error.jsp" %>
<jsp:include page="LocaleSetting.jsp" />
<jsp:include page="common.jsp" />
<jsp:include page="Title.jsp" />
<html>
<head>
<!--   Scriplet to get the category list 													-->
<%
	String eiPortletName=Configuration.CONFIG_PARAM_EI_PORTLET_NAME.getValue();
	List eiCategories= (List) request.getSession().getAttribute(ConfigConstants.SESSION_EI_CATEGORY_LIST);
	List eiAlertFilters=(List) request.getSession().getAttribute(ConfigConstants.SESSION_EI_ALERT_FILTERS);
	
	String selectedEICategory= (String) request.getSession().getAttribute(ConfigConstants.SESSION_SELECTED_EI_CATAGORY_NAME);	
	String selectedRunGroup= (String) request.getSession().getAttribute(ConfigConstants.SESSION_SELECTED_RUN_GROUP_ID);	
	String selectedAlertFilter= (String) request.getSession().getAttribute(ConfigConstants.SESSION_SELECTED_EI_ALERT_FILTER_NAME);	
	
	String eiDisplayEmergingIssuesListAction="DisplayEmergingIssuesListAction.do";
	String eiDisplayEmergingIssuesListPortletAction=WebUtil.makePortletAction(eiPortletName,eiDisplayEmergingIssuesListAction);	
	
	String eiDetailsAction="DisplayEmergingIssuesDetailsAction.do";
	String eiDetailsPortletAction=WebUtil.makePortletAction(eiPortletName,eiDetailsAction);	

%>

<!--   Java script to handle the category and run group selected changed events 			-->
<%@page import="com.sas.analytics.mfg.warranty.core.Configuration"%>
<script language="javascript">
	function setExportOutputType(sel){
	    window.parent.document.getElementById("exportOutputTypeValue").value = sel.options[sel.selectedIndex].value;
	}

	function eiCategorySelectionChanged(categoryDropDown){
		reloadEIDetails();
	}
	
	function eiRunGroupSelectionChanged(){		
		reloadEIDetails();		
	} // End of eiRunGroupSelectionChanged	

	function eiAlertSelectionChanged(){	
		reloadEIDetails();
	
	}// End of eiAlertSelectionChanged
	
	function reloadEIDetails(){
		var eiform = document.getElementById( "<%=ConfigConstants.EI_LIST_FORM_NAME%>");		
		eiform.submit();
	}
	
</script>

</head>

<body onload=javascript:setExportOutputType(window.document.getElementById("eiAlertAction"));>
<%


String initFilterActionName ="InitFilterAction.do";
String processingActionName ="EIProcessingAction.do";
String initFilterActionPath = WebUtil.makePortletAction(eiPortletName,initFilterActionName);
String processingActionPath = WebUtil.makePortletAction(eiPortletName,processingActionName);



%>
<form id="eiForm" name="eiForm" method="post"
	action="<%=eiDisplayEmergingIssuesListPortletAction %>" target="_self">	

	
<table width="<%=Configuration.EI_PORTLET_WIDTH.getValue()%>" >			
<tr> <td> <table>
	<tr>
		<td>
		    <%=WebUtil.getStringResource("EmergingIssuesList.eiCategory.control.label.txt", request )%>
		</td>
		<td align="left" colspan="3">
			<select name="<%=ConfigConstants.REQUEST_SELECTED_EI_CATAGORY_NAME%>" id="<%=ConfigConstants.REQUEST_SELECTED_EI_CATAGORY_NAME%>"
				onChange="eiCategorySelectionChanged()">
				<%
					//TODO: Check if we can separate the java code and html with this jsp more elegantly
						EICategoryResults selectedCategory = null;
						String categoryName = null;
						String ordinalValue = "-1";
						for( int catIndex = 0; catIndex < eiCategories.size( ); catIndex++ ) {
							EICategoryResults result=(EICategoryResults)eiCategories.get(catIndex);
							categoryName = result.getCategoryName();
							ordinalValue = result.getCategoryId( )+"";
							if( ordinalValue.equalsIgnoreCase(selectedEICategory)) {
								selectedCategory = result;
										%>	
								<option selected value="<%=ordinalValue%>"><%=categoryName%>
								</option>
							<% } else {
							%>
								<option value="<%=ordinalValue%>"><%=categoryName%>
								</option>
							<%
								}
						}
				%>
			</select>
		</td>				
	</tr>			
		
<%
	if( selectedCategory != null && selectedCategory.getEIType().equals(EIType.THRESHOLD)==false) {
%>
	<tr>
		<td>						
			<%=WebUtil.getStringResource("EmergingIssuesList.runGroup.control.label.txt", request )%>						
		</td>
		<td colspan="3">					
			<select name="<%=ConfigConstants.REQUEST_SELECTED_RUN_GROUP_ID%>" id="<%=ConfigConstants.REQUEST_SELECTED_RUN_GROUP_ID%>"
				onChange="eiRunGroupSelectionChanged()" align="left">		
			<%

					String []descriptorNames= selectedCategory.getEIAlertOrganizerDescriptorNames(request );
					String []descriptorIds = selectedCategory.getEIAlertOrganizerDescriptorIds(request );
					for ( int index = 0; index < descriptorNames.length; index++ ) {
						if(descriptorIds[index].equalsIgnoreCase(selectedRunGroup) ) {
							%>
							<option selected value="<%=descriptorIds[index]%>"><%=descriptorNames[index]%>
								</option>
							<% } else {
								%>
								<option value="<%=descriptorIds[index]%>"><%=descriptorNames[index]%>
								</option>
								<%					
						}
					}
			%>
			</select>				
		</td>				
	</tr>	
<%
	}	
	if( selectedCategory != null && selectedCategory.getEIType().equals(EIType.NEWMODEL)==false) {
%>
	<tr>
		<td>
			<%=WebUtil.getStringResource("EmergingIssuesList.eiAlertFilter.control.label.txt", request )%>
		</td>
		<td align="left">
			<select name="<%=ConfigConstants.REQUEST_SELECTED_EI_ALERT_FILTER_NAME%>" id="<%=ConfigConstants.REQUEST_SELECTED_EI_ALERT_FILTER_NAME%>"
					onChange="eiAlertSelectionChanged()">
			<%
					//TODO: Check if we can separate the java code and html with this jsp more elegantly
				if(eiAlertFilters!=null){
						for( int catIndex = 0; catIndex < eiAlertFilters.size( ); catIndex++ ) {
								EIAlertFilter alertFilter=(EIAlertFilter)eiAlertFilters.get(catIndex);
								String alertFilterName= alertFilter.toString(request.getLocale());
								ordinalValue = alertFilter.getOrdinalValue( )+"";
								if(ordinalValue.equalsIgnoreCase(selectedAlertFilter)) {
									%>	
									<option selected value="<%=ordinalValue%>"><%=alertFilterName%>
									</option>
								<% } else {
									%>
									<option value="<%=ordinalValue%>"><%=alertFilterName%>
									</option>
								<%
									}
						}
					}
						%>
			</select>
		</td>

		<td><%=WebUtil.getStringResource("Table.customColumn.control.label.txt", request )%></td>
		<td>
		    <select id="eiAlertAction" name="eiAlertAction" onchange="javascript:setExportOutputType(this)">
			    <option selected value="HTML"><%=WebUtil.getStringResource("Table.customColumn.viewHTML.label.txt", request )%></option>
			    <option value="PDF"><%=WebUtil.getStringResource("Table.customColumn.viewPDF.label.txt", request )%></option>
			</select>
		</td>
	</tr>
	
<%
  }
%>
 </table>
 </td> </tr> 
</table>	
</form>
</body>
</html>