<%@page contentType="text/html; charset=utf-8" %> 
<%@taglib uri='http://www.sas.com/taglib/sas' prefix='sas'%>
<%@page	import="com.sas.analytics.mfg.warranty.webapp.lpage.config.ConfigConstants"%>
<%@page	import="com.sas.analytics.mfg.warranty.webapp.lpage.util.WebUtil"%>
<%@page import="com.sas.analytics.mfg.warranty.core.Configuration"%>
<%@page import="com.sas.servlet.tbeans.tableview.TableCellContentsRenderer"%>
<%@page import="com.sas.servlet.tbeans.tableview.html.CellContentsNoRowsRenderer"%>
<%@page import="com.sas.servlet.tbeans.tableview.html.TableViewComposite"%>
<%@page import="com.sas.servlet.tbeans.tableview.html.TableView"%>
<%@page import="com.sas.actionprovider.ActionOrderList"%>
<%@page import="com.sas.actionprovider.support.ActionProviderSupportTypes"%>
<%@page import="com.sas.actionprovider.support.tableview.HttpTableViewSupport"%>
<%@page import="com.sas.servlet.tbeans.tableview.AbstractBaseTableView"%>
<%@page import="com.sas.actionprovider.HttpActionProvider"%>
<%@page import="javax.swing.table.TableModel"%>
<%@page import="java.util.Locale"%>
<%@page import="java.util.List"%>
<%@page import="java.text.MessageFormat"%>
<%@page import="com.sas.servlet.tbeans.html.*" %>
<%@page import="com.sas.analytics.mfg.warranty.webapp.lpage.BaseTableCellContentRenderer"%>
<%@page import="com.sas.servlet.util.JavaScriptIncludeHandler"%>
<%@page errorPage="error.jsp" %>
<jsp:include page="common.jsp" />
<!-- Displays the list of all reports for the selected category  -->

<!-- styles and scripts are necessary since iframe doesnt inherit anything from parent-->
<%
String contextPath=request.getContextPath();
String serverPath=WebUtil.getRequestScheme(request) + request.getServerName()+":" + request.getServerPort();
String scriptsPath=serverPath+contextPath+"/scripts/";
request.setAttribute(JavaScriptIncludeHandler.JS_PATH,scriptsPath);

String reportName = (String)request.getAttribute(ConfigConstants.PUBLIC_REPORTS_REPORT_NAME_COLUMN_NAME);
String tableListTabLabel=WebUtil.getStringResource("TabsView.ReportTablesPicker.Tab.Name.txt",request);
String tablesInReportTitle = MessageFormat.format(WebUtil.getStringResource("TabsView.ReportTablesPicker.PickerTable.Name.fmt.txt",request), new Object[] {reportName});
String processingMessage = WebUtil.getStringResource("EmergingIssuesList.runGroupAlertsValue.txt", request );
String publishedMessage = WebUtil.getStringResource("publicReportsTable.publishedColumn.label.txt", request );
String errorMessage = WebUtil.getStringResource("ErrorPage.title.txt", request );
%>


<sas:StyleSheet styleNames="SAS Style,SAS Portal"/>
<sas:InitializeComponents/>

<script language='javascript'>
	window.document.title = "<%=reportName%>";

    var excelWindow;
	
	function invokeExport(csvExportUrl)
	{
		// Set up the AJAX HTTP object, depending on browser type.
        var xmlhttp;
        if (window.XMLHttpRequest)
        {// code for IE7+, Firefox, Chrome, Opera, Safari
            xmlhttp=new XMLHttpRequest();
        }
        else
        {// code for IE6, IE5
            xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
        }

        // Define the function to call when the response comes back.        
        xmlhttp.onreadystatechange=function()
        {
            if (xmlhttp.readyState==4 && xmlhttp.status==200)
            {
				// Fish for the URL embedded in a "content" DIV from WriteUrlToResponse.jsp.
                var openDiv = '<div id="content">';
                var closeDiv = '</div>';
                var text = xmlhttp.responseText;
                var startIdx = text.indexOf(openDiv);
				if (startIdx == -1)
				{
					excelWindow.document.title = "<%=errorMessage%>";
					excelWindow.document.body.innerHTML = "<h2>" + "<%=errorMessage%>" + "</h2><pre>" + text + "</pre>";
				}
				else
				{
                    var stopIdx = text.indexOf(closeDiv);
	    			var csvUrl = text.substring(startIdx + openDiv.length, stopIdx);
					excelWindow.document.title = "<%=publishedMessage%>";
					excelWindow.document.body.innerHTML = "";
                    excelWindow.location = csvUrl;
				}
            }
        }

        // Kick off the AJAX call and start the window waiting for the response.
        // This must be on a timer so that it qualifies as a "user event" and 
        // thus brings up a new tab instead of a popup window.
		excelWindow = window.open("", "CSVDownload", "", "replace");
		excelWindow.document.title = "<%=processingMessage%>";
		excelWindow.document.body.innerHTML = "";
        xmlhttp.open("GET",csvExportUrl,true);
        xmlhttp.send();
	}
	
</script>

<div style="background-color: #003399; width:100%; border-bottom-style: inset;">
<BR>

<%
String publicReportsCategory=request.getParameter(ConfigConstants.REQUEST_SELECTED_PUBLIC_REPORT_CATAGORY_NAME);
String listCSVDownloadsAction="ListCSVDownloadsAction.do?"+
	   ConfigConstants.REQUEST_SELECTED_PUBLIC_REPORT_CATAGORY_NAME+"="+publicReportsCategory+"&";
String publicReportsPortletName=Configuration.CONFIG_PARAM_PUBLIC_REPORTS_PORTLET_NAME.getValue();
String controllerURL=WebUtil.makePortletAction(publicReportsPortletName,listCSVDownloadsAction);
TableModel sortableTable=(TableModel)session.getAttribute(ConfigConstants.SESSION_PUBLIC_REPORTS_TABLE_MODEL);
String stringRowPageSize=Configuration.PUBLIC_REPORTS_TABLE_ROW_PAGE_SIZE.getValue();
int rowPageSize=Integer.parseInt(stringRowPageSize);
rowPageSize=WebUtil.getRowPageSize( sortableTable,rowPageSize);
String stringColumnPageSize=Configuration.PUBLIC_REPORTS_TABLE_COLUMN_PAGE_SIZE.getValue();
int columnPageSize=Integer.parseInt(stringColumnPageSize);
columnPageSize=WebUtil.getColumnPageSize(sortableTable,columnPageSize);

%>

 <sas:TableViewComposite 
            id="PublicReportsTableViewComp"
			scope="session"
            render="false">    
                    
</sas:TableViewComposite>
<%
		HttpActionProvider newActionProvider=new HttpActionProvider();
		newActionProvider.setLocale( ( Locale) request.getAttribute( ConfigConstants.REQUEST_USER_LOCALE ) );
		newActionProvider.setControllerURL(controllerURL);

		TableViewComposite tableViewComposite=(TableViewComposite)session.getAttribute(ConfigConstants.SESSION_PUBLIC_REPORTS_TABLE_VIEW_NAME);
		tableViewComposite.setActionProvider(null);
		tableViewComposite.setActionProvider(newActionProvider);
		tableViewComposite.setModel(sortableTable);
		TableView table =(TableView)tableViewComposite.getComponent(tableViewComposite.TABLEVIEW_TABLEDATA);
		table.setColumnsResizable(true);
		table.setTextWrapping(AbstractBaseTableView.WRAP_ALL);
		ActionOrderList columnHeaderList = newActionProvider.getActionOrderList(ActionProviderSupportTypes.TABLEVIEW_SUPPORT, table, HttpTableViewSupport.COLUMN_HEADER_AREA);
		ActionOrderList actionSubList=(ActionOrderList)columnHeaderList.get(0);
		actionSubList.remove(HttpTableViewSupport.EXPORT_TO_ACTION);
		
		List sortColumnsProfile = (List)session.getAttribute(ConfigConstants.SESSION_SORT_ORDER_COLUMNS_SUFFIX);
		List sortDirectionsProfile = (List)session.getAttribute(ConfigConstants.SESSION_SORT_ORDER_DIRECTIONS_SUFFIX);
		if (sortColumnsProfile != null && sortDirectionsProfile != null)
		{
			table.setSortedColumns(sortColumnsProfile, sortDirectionsProfile);
		}

		TableCellContentsRenderer defaultNoRowRenderer = table.getDefaultNoRowsRenderer( );
		if ( defaultNoRowRenderer instanceof CellContentsNoRowsRenderer ) {
			String defaultNoRowsText = WebUtil.getStringResource("PublicReports.NoRows.txt", request );
			( ( CellContentsNoRowsRenderer ) defaultNoRowRenderer).setText( defaultNoRowsText );
		}

	    String viewExportColumnLabel = WebUtil.getStringResource("Table.customColumn.exportAction.label.txt", request );
	    String tableNameColumnLabel = WebUtil.getStringResource("publicReportsTable.reportNameColumn.label.txt", request );
	    String reportIdProxyColumnName = Configuration.VIEW_EXPORT_COLUMN_NAME_KEY.getValue();

	    String exportImagePath=serverPath + contextPath +"/images/Export.gif";

		table.setDefaultRenderer(new BaseTableCellContentRenderer(( Locale) request.getAttribute( ConfigConstants.REQUEST_USER_LOCALE )));

		String downloadCSVAction = "GenerateCSVFileAndWriteToContentServer.do?"+
	  		ConfigConstants.REQUEST_SELECTED_ROW_NUMBER +"=%MODEL_ROW_NUMBER&"+
	   		ConfigConstants.REQUEST_SELECTED_PUBLIC_REPORT_CATAGORY_NAME+"="+publicReportsCategory+"&"+
	   		ConfigConstants.REQUEST_SELECTED_TABLE_NAME+"=%" + reportIdProxyColumnName + "&";
%>

<%
  	TabMenu tabMenu = new TabMenu();
    tabMenu.setId("someTabMenuId");
	tabMenu.setLook(TabMenu.BANNER_TAB_LOOK);
    TabButton tableListTab = new TabButton();
    tableListTab.setId("tableListTab");
    tableListTab.setTitle(tableListTabLabel);
    tableListTab.setLabel(tableListTabLabel);
    tableListTab.setOnClick("showPage('1');");
    tabMenu.add(tableListTab);
 
	tabMenu.setRequest(request);
	tabMenu.setResponse(response); 
%>


	<%
		String pageNo=request.getParameter("pageNo");
		if(pageNo==null || pageNo.equals("1"))
		{
			tabMenu.setActiveTab(tableListTab);
			tabMenu.write(out);
		}
	%>
</div>

<table align="center"><tr><td align="center">

<b><%=tablesInReportTitle%></b>

</td></tr><tr><td align="center">

<sas:TableViewComposite 
           ref="PublicReportsTableViewComp"
           scope="session"
		   locale="<%=( Locale) request.getAttribute( ConfigConstants.REQUEST_USER_LOCALE )%>"
           render="true">  
    <sas:TableView 
        id="PublicReportsSAViewer"							
        rowHeaderVisible="true" 
        cellPadding="1" 
        cellSpacing="3"
        borderWidth="1" 
        autoCreateColumnsFromModel="true"  
        rowPageSize="<%=rowPageSize %>" 
        columnPageSize="<%= columnPageSize%>"
        widthPercentage="100"> 
        
        <sas:Columns>
            <sas:Column headerValue="<%=viewExportColumnLabel%>" modelIndex="<%=ConfigConstants.VIEW_EXPORT_COL%>" hold="LEFT">                        	                                     
                <sas:CellRenderer>
                    <sas:CellContentsSimpleTemplateRenderer> 
                        <a href="javascript:" onclick='invokeExport("<%=downloadCSVAction%>");' ><img src="<%=exportImagePath%>" border="0"></a>
                    </sas:CellContentsSimpleTemplateRenderer>
                </sas:CellRenderer>
            </sas:Column>                        
            <sas:Column headerValue="<%=tableNameColumnLabel%>" modelIndex="<%=ConfigConstants.REPORT_NAME_COL %>" hold="LEFT">
            </sas:Column>
        </sas:Columns>	
    </sas:TableView>			
</sas:TableViewComposite>           

</td></tr></table>
