<%@page contentType="text/html; charset=utf-8" %> 
<%@taglib uri='http://www.sas.com/taglib/sas' prefix='sas'%>
<%@page	import="com.sas.analytics.mfg.warranty.webapp.lpage.config.ConfigConstants"%>
<%@page	import="com.sas.analytics.mfg.warranty.webapp.lpage.util.WebUtil"%>
<%@page	import="com.sas.analytics.mfg.warranty.core.Configuration"%>
<%@page	import="java.text.MessageFormat"%>
<%@ page import="com.sas.servlet.tbeans.html.*" %>
<%@ page import="javax.swing.tree.*" %>
<%@page import="com.sas.servlet.util.JavaScriptIncludeHandler"%>
<%@page errorPage="error.jsp" %>
<html>
<body>
<%
String contextPath=request.getContextPath();
String serverPath=WebUtil.getRequestScheme(request) + request.getServerName()+":" + request.getServerPort();
String scriptsPath=serverPath+contextPath+"/scripts/";
request.setAttribute(JavaScriptIncludeHandler.JS_PATH,scriptsPath);
%>


<sas:StyleSheet styleNames="SAS Style,SAS Portal"/>
<sas:InitializeComponents/>
<jsp:include page="common.jsp" />
<div style="background-color: #003399; width:100%; border-bottom-style: inset;">
<BR>
<%
String swaSessionId=request.getParameter(ConfigConstants.SWA_SESSION_ID);
String selectedReportId = request.getParameter(ConfigConstants.REQUEST_SELECTED_REPORT_ID);
int selectedRowNumber=WebUtil.getSelectedRowNumber(request);

String hasPrivilege = ( String) request.getParameter(ConfigConstants.REQUEST_PARAM_HAS_DRILL_DOWN_PRIVILEGE);

String publicReportsCategory=request.getParameter(ConfigConstants.REQUEST_SELECTED_PUBLIC_REPORT_CATAGORY_NAME);
String pageNo=request.getParameter("pageNo");

String publicReportsPortletName=Configuration.CONFIG_PARAM_PUBLIC_REPORTS_PORTLET_NAME.getValue();
String noOfImages = ( String) request.getParameter(ConfigConstants.REQUEST_NO_OF_IMAGES_ATTRIBUTE_NAME);
String noOfTables = ( String) request.getParameter(ConfigConstants.REQUEST_NO_OF_TABLES_ATTRIBUTE_NAME);
String graphCreatorRequestHashCode = ( String) request.getParameter(ConfigConstants.REQUEST_GRAPH_CREATOR_REQUEST_HASHCODE);
String forwardActionName = null;

String	defaultActionName ="PublicReportsViewAction.do";
String	reloadActionName ="ReloadPublicReportsGraph.do";

String defaultActionPath = WebUtil.makePortletAction(publicReportsPortletName,defaultActionName);
String reloadActionPath = WebUtil.makePortletAction(publicReportsPortletName,reloadActionName);

//Fix for defect S0546286 --Start
//jpnmai
String title=(String) request.getAttribute(ConfigConstants.PUBLIC_REPORTS_REPORT_NAME_COLUMN_NAME);
String reportName = ( String) request.getParameter(ConfigConstants.PUBLIC_REPORTS_REPORT_NAME_COLUMN_NAME);
if(title != null){
	request.setAttribute(ConfigConstants.PUBLIC_REPORTS_REPORT_NAME_COLUMN_NAME,title);
}else{
	title = reportName;
}


  reportName = WebUtil.encode(title, request);

//jpnmai
//Fix for defect S0546286 --End

String detailsLabel=WebUtil.getStringResource("TabsView.Details.Tab.Name.txt",request);
String resultsLabel=WebUtil.getStringResource("TabsView.Results.Tab.Name.txt",request);

%>



<script language="javascript">

	function showPage(pageNo) {
		var forwardActionPath = '<%=reloadActionPath%>' ;
		if( pageNo == "2" ) {
			forwardActionPath ='<%=defaultActionPath%>' ;
		}
		var actionURL=	forwardActionPath + "?"																+		
						"pageNo=" + pageNo + "&"															+
						"<%=ConfigConstants.SWA_SESSION_ID%>=<%=swaSessionId%>&"							+
						"<%=ConfigConstants.REQUEST_SELECTED_REPORT_ID%>=<%=selectedReportId%>&"			+
						"<%=ConfigConstants.REQUEST_SELECTED_ROW_NUMBER%>=<%=selectedRowNumber%>&"			+
						"<%=ConfigConstants.REQUEST_PARAM_HAS_DRILL_DOWN_PRIVILEGE%>=<%=hasPrivilege%>&"	+
						"<%=ConfigConstants.REQUEST_SELECTED_PUBLIC_REPORT_CATAGORY_NAME%>="				+ "<%=publicReportsCategory%>&"														+
						"<%=ConfigConstants.REQUEST_NO_OF_IMAGES_ATTRIBUTE_NAME%>=<%=noOfImages%>&"			+
						"<%=ConfigConstants.REQUEST_NO_OF_TABLES_ATTRIBUTE_NAME%>=<%=noOfTables%>&"			+	
						"<%=ConfigConstants.PUBLIC_REPORTS_REPORT_NAME_COLUMN_NAME%>=<%=reportName%>&"+
						"<%=ConfigConstants.REQUEST_GRAPH_CREATOR_REQUEST_HASHCODE%>=<%=graphCreatorRequestHashCode%>&"
						;
		window.location=actionURL;				
				
	} // end of showPage
	
	// Set window title 	
		<%
			String messagePattern=WebUtil.getStringResource("publicReports.viewHtml.window.title.fmt",request);

			Object[] arguments=new Object[1];
			arguments[0]=title;
			String windowTitle=MessageFormat.format(messagePattern,arguments);				
		%>
	window.document.title="<%=WebUtil.applyEscapeProcessing(windowTitle)%>";
	// End Set window title
</script>

<%
  	  TabMenu tabMenu = new TabMenu();
      tabMenu.setId("someTabMenuId");
	  tabMenu.setLook(TabMenu.BANNER_TAB_LOOK);
      TabButton resultsTab= new TabButton();
      resultsTab.setId("ResultsTab");
      resultsTab.setTitle(resultsLabel);
      resultsTab.setLabel(resultsLabel);
      resultsTab.setOnClick("showPage('1');");
      tabMenu.add(resultsTab);
 
      TabButton detailsTab= new TabButton();
      detailsTab.setId("DetailsTab");
      detailsTab.setLabel(detailsLabel);
      detailsTab.setTitle(detailsLabel);
      detailsTab.setOnClick("showPage('2');");
      tabMenu.add(detailsTab);
tabMenu.setRequest(request);
tabMenu.setResponse(response); 
%>


	<%
		if(pageNo==null || pageNo.equals("1")){
			tabMenu.setActiveTab(resultsTab);
			tabMenu.write(out);
	%>
	</div>

<jsp:include page="PublicReportsGraphView.jsp" flush="true"/>

	<%
		} else if(pageNo.equals("2")){
		tabMenu.setActiveTab(detailsTab);		
		tabMenu.write(out);
	%>
	</div>
<jsp:include page="PublicReportsDetailsView.jsp" flush="true"/>
	<%
	}	
	%>

</body>
</html>