<%@page contentType="text/html; charset=utf-8" %> 
<%@page
	import="com.sas.analytics.mfg.warranty.webapp.lpage.config.ConfigConstants"%>
<%@page
	import="com.sas.analytics.mfg.warranty.webapp.lpage.util.WebUtil"%>
<%@page import="com.sas.analytics.mfg.warranty.core.Configuration"%>
<%@page import="com.sas.servlet.util.JavaScriptIncludeHandler"%>
<%@page import="java.util.List"%>
<%@page errorPage="error.jsp" %>
<%@taglib uri='http://www.sas.com/taglib/sas' prefix='sas'%>
<jsp:include page="common.jsp" />

<%
String contextPath=request.getContextPath();
String serverPath=WebUtil.getRequestScheme(request) + request.getServerName()+":" + request.getServerPort();
String scriptsPath=serverPath+contextPath+"/scripts/";
request.setAttribute(JavaScriptIncludeHandler.JS_PATH,scriptsPath);
%>


<sas:StyleSheet styleNames="SAS Style,SAS Portal"/>
<sas:InitializeComponents/>

<script language="javascript">
var allFilters = '';

<%
String publicReportsPortletName=Configuration.CONFIG_PARAM_PUBLIC_REPORTS_PORTLET_NAME.getValue();

String publicReportsApplyFilterAction="PublicReportsApplyFilterPortletAction.do";
String publicReportsApplyFilterPortletAction=WebUtil.makePortletAction(publicReportsPortletName,publicReportsApplyFilterAction);

String publicReportsClearFilterAction="PublicReportsClearFilterPortletAction.do";
String publicReportsClearFilterPortletAction=WebUtil.makePortletAction(publicReportsPortletName,publicReportsClearFilterAction);
%>

function applyPublicReportsFilter()
{
		var publicReportsForm=window.parent.document.getElementById("publicReportsForm");
		var searchTextValue=document.getElementById("<%=ConfigConstants.REQUEST_PUBLIC_REPORTS_FILTER_SEARCH_TEXT_NAME %>").value;
		
		// fix for defect S0550960---->start
		if (typeof(encodeURIComponent) == 'function') { 
			searchTextValue = encodeURIComponent(searchTextValue);
		} 
		// fix for defect S0550960---->end

		var searchTextLabel="<%=ConfigConstants.REQUEST_PUBLIC_REPORTS_FILTER_SEARCH_TEXT_NAME %>";
		var searchCriteriaValue=getPublicReportsFilterCriteria();		
		if(searchTextValue== null || searchTextValue.length == 0)
		{
			alert('<%= WebUtil.applyEscapeProcessing(WebUtil.getStringResource("LoadFilterCriteriaAction.invalid.filter.criteria.txt", request ))%>');
		}
		else
		{		
			var searchCriteriaLabel="<%=ConfigConstants.REQUEST_PUBLIC_REPORTS_FILTER_SEARCH_CRITERIA_NAME %>";
			var actionURL="<%=publicReportsApplyFilterPortletAction%>"+"?"+searchTextLabel+"="+searchTextValue+"&"+
				searchCriteriaLabel+"="+searchCriteriaValue+"&";
			publicReportsForm.action=actionURL;
			var publicReportsDetailsIframe=window.parent.document.getElementById("publicReportsDetails");
			publicReportsDetailsIframe.src = publicReportsDetailsIframe.src;
			if (allFilters != "")
			{
			    allFilters += " ";
			}
			allFilters += searchTextValue;
			publicReportsForm.<%=ConfigConstants.REQUEST_PUBLIC_REPORTS_FILTER_SEARCH_TEXT_NAME %>.value = '';
			publicReportsForm.<%=ConfigConstants.REQUEST_PUBLIC_REPORTS_CUMULATIVE_FILTER_SEARCH_TEXT_NAME%>.value = allFilters;
		}		
}

function getPublicReportsFilterCriteria(){
		var publicReportsForm=window.parent.document.getElementById("publicReportsForm");
		for(i=0;i<publicReportsForm.<%=ConfigConstants.REQUEST_PUBLIC_REPORTS_FILTER_SEARCH_CRITERIA_NAME %>.length;i++){
			if(publicReportsForm.<%=ConfigConstants.REQUEST_PUBLIC_REPORTS_FILTER_SEARCH_CRITERIA_NAME %>[i].checked==true)
			{
				return publicReportsForm.<%=ConfigConstants.REQUEST_PUBLIC_REPORTS_FILTER_SEARCH_CRITERIA_NAME %>[i].value;
			}
		}
}

function clearPublicReportsFilter()
{
		var publicReportsForm=window.parent.document.getElementById("publicReportsForm");
		publicReportsForm.action="<%=publicReportsClearFilterPortletAction%>";
		var publicReportsDetailsIframe=window.parent.document.getElementById("publicReportsDetails");		
		publicReportsDetailsIframe.src = publicReportsDetailsIframe.src;
		clearFilterFields( publicReportsForm );
		allFilters = '';
		publicReportsForm.<%=ConfigConstants.REQUEST_PUBLIC_REPORTS_CUMULATIVE_FILTER_SEARCH_TEXT_NAME%>.value = allFilters;
}
</script>

<table rows="3" cols="4">
	<tr>
        <td><table><tr>
		<td>
		<%=WebUtil.getStringResource("publicReportFilterSearchText.label.txt", request )%>
		</td>
		<td align="left">
			<input 
				type="text" 
				name="<%=ConfigConstants.REQUEST_PUBLIC_REPORTS_FILTER_SEARCH_TEXT_NAME %>" id="<%=ConfigConstants.REQUEST_PUBLIC_REPORTS_FILTER_SEARCH_TEXT_NAME %>">
		</td>
		<td>
			<input 
					type="radio" 
					name="<%=ConfigConstants.REQUEST_PUBLIC_REPORTS_FILTER_SEARCH_CRITERIA_NAME %>" 

					value="<%=ConfigConstants.PUBLIC_REPORTS_FILTER_CONTAINS_VALUE%>" 
					checked> 
					<%=WebUtil.getStringResource("publicReportFilterSearchCriteria.contains.label.txt", request )%>
					
		</td>
		<td>
			<input 
				type="radio" 
				name="<%=ConfigConstants.REQUEST_PUBLIC_REPORTS_FILTER_SEARCH_CRITERIA_NAME %>" 
				value="<%=ConfigConstants.PUBLIC_REPORTS_FILTER_STARTS_WITH_VALUE%>"
				> 
				<%=WebUtil.getStringResource("publicReportFilterSearchCriteria.startsWith.label.txt", request )%>
		</td>
		</tr></table></td>
	</tr>
	<tr >
		
        <td><table><tr>
		<td>		
			<sas:Button name="applyButton" id="applyButton" label='<%=WebUtil.encodeXML(WebUtil.getStringResource("publicReportsFilter.applyButton.label.txt", request ))%>' onClick="javascript:applyPublicReportsFilter()">
			</sas:Button>
		</td>
		<td>
			<sas:Button name="clearButton" id="clearButton" label='<%=WebUtil.encodeXML(WebUtil.getStringResource("publicReportsFilter.clearButton.label.txt", request ))%>' onClick="javascript:clearPublicReportsFilter()">
			</sas:Button>
		</td>
		<td align="center">
		<%=WebUtil.getStringResource("publicReportFilterSearchCriteria.currentFilter.label.txt", request )%>
		</td>
		<td align="left">
			<input 
				type="text" 
				name="<%=ConfigConstants.REQUEST_PUBLIC_REPORTS_CUMULATIVE_FILTER_SEARCH_TEXT_NAME %>" 
				id="<%=ConfigConstants.REQUEST_PUBLIC_REPORTS_CUMULATIVE_FILTER_SEARCH_TEXT_NAME %>"
				size="50"
				disabled>
		</td>
		</tr></table></td>
		
	</tr>
</table>

